#include	<stdio.h>
#include	<string.h>

#define	MAX_LST_LINE	256
#define	LST_OFFSET	20
/* 0123456789012345678901 -> 20 */
/* XXXXXXXX XX XX XX XX****   */
/* AhX͍ŏSAőW */
static	char	Lst_bf[MAX_LST_LINE] = { "" };
static	unsigned	long	Old_adr;
static	int	Set_cnt, Set_byte;

#ifdef	PROTOTYPE1
int lst_name(unsigned long,char *,FILE *);
int lst_data(unsigned long,unsigned char,FILE *);
int lst_end(FILE *);
#else
int lst_name();
int lst_data();
int lst_end();
#endif

#ifdef	PROTOTYPE1
int		lst_name( unsigned long adr, char *name, FILE *fp )
#else
int		lst_name( adr, name, fp )
unsigned	long	adr;
char	*name;
FILE	*fp;
#endif
{
	char	temp[20];

	if( *Lst_bf != 0x00 ) {
		lst_end( fp );
	}
	if( strlen( name ) >= (MAX_LST_LINE-LST_OFFSET) ) {
		return( -1 );
	}
	sprintf( temp, "%04lX", adr );
	Set_cnt = 0;
	Set_byte = strlen( temp );
	Old_adr = adr;
	memset( Lst_bf, ' ', (LST_OFFSET+1) );
	strncpy( Lst_bf, temp, strlen( temp ) );
	if( Set_byte == 8 ) {
		strcpy( &Lst_bf[LST_OFFSET+1], name );
	} else {
		strcpy( &Lst_bf[LST_OFFSET], name );
	}
	if( Lst_bf[strlen(Lst_bf)-1] == '\n' ) {
		Lst_bf[strlen(Lst_bf)-1] = 0x00;
	}
	/* for MS-DOS */
	if( Lst_bf[strlen(Lst_bf)-1] == 0xd ) {
		Lst_bf[strlen(Lst_bf)-1] = 0x00;
	}
	return( 0 );
}

#ifdef	PROTOTYPE1
int		lst_data( unsigned long adr, unsigned char dt, FILE *fp )
#else
int		lst_data( adr, dt, fp )
unsigned	long	adr;
unsigned	char	dt;
FILE	*fp;
#endif
{
	char	temp[20], *p;
	int		cnt;

	if( *Lst_bf == 0x00 ) {
		/*	VKi[Ȃ	*/
		memset( Lst_bf, 0x00, MAX_LST_LINE );
		sprintf( Lst_bf, "%04lX %02X", adr, dt );
		Old_adr = adr;
		Set_cnt = 1;
		Set_byte = strlen( Lst_bf );
		return( 0 );
	} else {
		/*	i[ĂȂ	*/
		cnt = 0;
		while( Lst_bf[cnt++] != ' ' );
		if( Lst_bf[cnt] == ' ' ) {
			/*	f[^ݒŃAhX	*/
			if( adr != Old_adr ) {
				lst_end( fp );
				return( lst_data( adr, dt, fp ) );
			}
		} else {
			/*	f[^ݒŃAhX	*/
			if( (adr-1L) != Old_adr ) {
				lst_end( fp );
				return( lst_data( adr, dt, fp ) );
			}
		}
	}
	/*	f[^ǉ	*/
	sprintf( temp, " %02X", dt );
	strncpy( &Lst_bf[Set_byte], temp, 3 );
	Set_byte += 3;
	if( (++Set_cnt) == 4 ) {
		lst_end( fp );
	}
	Old_adr = adr;
	return( 0 );
}

#ifdef	PROTOTYPE1
int		lst_end( FILE *fp )
#else
int		lst_end( fp )
FILE	*fp;
#endif
{
	if( *Lst_bf ) {
		if( fp == NULL ) {
			printf( "%s\n", Lst_bf );
		} else {
			fprintf( fp, "%s\n", Lst_bf );
		}
		*Lst_bf = 0x00;
	}
	return( 0 );
}

#ifdef	DEBUG_MAIN
int		main()
{
	unsigned	long	adr;
	int		n;

	lst_data( 0x100L, 0x77, NULL );
	lst_name( 0x100L, "long adr", NULL );
	lst_data( 0x12345678L, 0x88, NULL );
	adr = 0x123L;
	lst_name( 0x1L, "tst1dat", NULL );
	for( n=1; n<13; n++ ) {
		lst_data( (long)n, n, NULL );
	}
	lst_data( 0x300L, 255, NULL );
	lst_name( 0x87654321L, "tst2dat", NULL );
	for( n=0; n<33; n++ ) {
		lst_data( 0x87654321L+(long)n, n, NULL );
	}
	lst_name( 0x301L, "tst2dat", NULL );
	lst_name( 0x500L, "tst3dat", NULL );
	for( n=20; n<33; n++ ) {
		lst_data( adr+(long)n, n, NULL );
	}
	lst_name( 0x600L, "tst4dat", NULL );
	lst_end( NULL );
	return( 0 );
}
#endif
